// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/ShaderManager.hpp"
#include "scene/components/display/material/SimpleTexturedMaterial.hpp"
#include "display/shader/ShaderParameterBuffer.hpp"

namespace Dawn {
  struct Test123 {
    float_t r;
    float_t g;
    float_t b;
  };

  class SimpleTexturedShaderTest : public ShaderParameterBuffer<struct Test123> {
  };
  
  class SimpleTexturedShaderProgram : public ShaderProgram {
    public:
      SimpleTexturedShaderTest test;

      shaderparameter_t paramProjection;
      shaderparameter_t paramView;
      shaderparameter_t paramModel;
      shaderparameter_t paramColor;
      shaderparameter_t paramTexture;
      shaderparameter_t paramHasTexture;

      void compile() override;
  };

  class SimpleTexturedShader : public Shader {
    public:
      SimpleTexturedShaderProgram program;

      void compile() override;

      std::vector<struct ShaderPassItem> getPassItems(
        Mesh *mesh,
        Material *material,
        Camera *camera
      ) override;
  };
}